package com.annimon.ownlang;

import com.annimon.ownlang.lib.CallStack;

import java.util.Enumeration;

public class Console {
    
    public static void print(String value) {
        Main.printToConsole(value);
    }

    public static void print(Object value) {
        print(value.toString());
    }

    public static void println() {
        Main.printToConsole("\n");
    }

    public static void println(String value) {
        Main.printToConsole(value + "\n");
    }

    public static void println(Object value) {
        println(value.toString());
    }

    public static void error(Throwable throwable) {
        error(throwable.toString());
    }

    public static void error(String value) {
        Main.printToConsole(value);
    }
    
    public static void handleException(Thread thread, Throwable throwable) {
        final StringBuffer sb = new StringBuffer();
        sb.append(throwable.getMessage()).append(" in ").append(thread.getName()).append('\n');
        for (Enumeration en = CallStack.getCalls().elements(); en.hasMoreElements();) {
            final CallStack.CallInfo call = (CallStack.CallInfo) en.nextElement();
            sb.append("\tat ").append(call).append('\n');
        }
        sb.append('\n');
        error(sb.toString());
    }
}
