package com.annimon.ownlang.lib.modules.functions;

import com.annimon.ownlang.exceptions.ArgumentsMismatchException;
import com.annimon.ownlang.exceptions.TypeException;
import com.annimon.ownlang.lib.*;
import com.annimon.stream.Collectors;
import com.annimon.stream.Comparator;
import com.annimon.stream.Stream;
import java.util.Vector;

public final class functional_sortby implements Function {

    /*@Override*/
    public Value execute(Value[] args) {
        if (args.length != 2) throw new ArgumentsMismatchException("Two arguments expected");
        
        if (args[0].type() != Types.ARRAY) {
            throw new TypeException("Array expected in first argument");
        }
        if (args[1].type() != Types.FUNCTION) {
            throw new TypeException("Function expected in second argument");
        }
        
        final Value[] elements = ((ArrayValue) args[0]).getCopyElements();
        final Function function = ((FunctionValue) args[1]).getValue();
        Vector v = (Vector) Stream.of(elements).sorted(new Comparator() {

            public int compare(Object o1, Object o2) {
                final Value v1 = (Value) function.execute(new Value[]{(Value)o1});
                return v1.compareTo((Value)function.execute(new Value[]{(Value)o2}));
            }
        }).collect(Collectors.toList());
        return new ArrayValue(v);
    }
    
}