package com.annimon.ownlang.lib.modules.functions;

import com.annimon.ownlang.exceptions.ArgumentsMismatchException;
import com.annimon.ownlang.exceptions.TypeException;
import com.annimon.ownlang.lib.*;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

public final class std_arrayKeys implements Function {

    /*@Override*/
    public Value execute(Value[] args) {
        if (args.length != 1) throw new ArgumentsMismatchException("One argument expected");
        if (args[0].type() != Types.MAP) {
            throw new TypeException("Map expected in first argument");
        }
        final MapValue map = ((MapValue) args[0]);
        final Vector keys = new Vector(map.size());
        for (Enumeration en = ((Hashtable) map.raw()).keys(); en.hasMoreElements();) {
            keys.addElement(en.nextElement());
        }
        return new ArrayValue(keys);
    }
    
}