package com.annimon.ownlang.lib.modules.functions;

import com.annimon.ownlang.exceptions.ArgumentsMismatchException;
import com.annimon.ownlang.exceptions.TypeException;
import com.annimon.ownlang.lib.*;
import java.util.Enumeration;

public final class std_join implements Function {

    /*@Override*/
    public Value execute(Value[] args) {
        if (args.length < 1) throw new ArgumentsMismatchException("At least one argument expected");
        if (args[0].type() != Types.ARRAY) {
            throw new TypeException("Array expected in first argument");
        }
        
        final ArrayValue array = (ArrayValue) args[0];
        switch (args.length) {
            case 1:
                return join(array, "", "", "");
            case 2:
                return join(array, args[1].asString(), "", "");
            case 3:
                return join(array, args[1].asString(), args[2].asString(), args[2].asString());
            case 4:
                return join(array, args[1].asString(), args[2].asString(), args[3].asString());
            default:
                throw new ArgumentsMismatchException("Wrong number of arguments");
        }
    }
    
    private static StringValue join(ArrayValue array, String delimiter, String prefix, String suffix) {
        final StringBuffer sb = new StringBuffer();
        for (Enumeration en = array.iterator(); en.hasMoreElements();) {
            final Value value = (Value) en.nextElement();
            if (sb.length() > 0) sb.append(delimiter);
            else sb.append(prefix);
            sb.append(value.asString());
        }
        sb.append(suffix);
        return new StringValue(sb.toString());
    }
}