package com.annimon.ownlang.parser;

/**
 *
 * @author aNNiMON
 */
public final class TokenType {

    public static final TokenType
            NUMBER = new TokenType(1, "<NUMBER>"), // 5, 9.81
            HEX_NUMBER = new TokenType(2, "<HEX_NUMBER>"), // 0xCAFEBABE
            WORD = new TokenType(3, "<WORD>"), // 0b110010
            TEXT = new TokenType(4, "<TEXT>"), // "text"
    
            // keyword
            PRINT = new TokenType(5, "print"),
            PRINTLN = new TokenType(6, "println"),
            IF = new TokenType(7, "if"),
            ELSE = new TokenType(8, "else"),
            WHILE = new TokenType(9, "while"),
            FOR = new TokenType(10, "for"),
            DO = new TokenType(11, "do"),
            BREAK = new TokenType(12, "break"),
            CONTINUE = new TokenType(13, "continue"),
            DEF = new TokenType(14, "def"),
            RETURN = new TokenType(15, "return"),
            USE = new TokenType(16, "use"),
            MATCH = new TokenType(17, "match"),
            CASE = new TokenType(18, "case"),
            EXTRACT = new TokenType(19, "extract"),
            INCLUDE = new TokenType(20, "include"),

            PLUS = new TokenType(20, "+"), // +
            MINUS = new TokenType(21, "-"), // -
            STAR = new TokenType(22, "*"), // *
            SLASH = new TokenType(23, "/"), // /
            PERCENT = new TokenType(24, "%"),// %

            EQ = new TokenType(25, "="), // =
            EQEQ = new TokenType(26, "=="), // ==
            EXCL = new TokenType(27, "!"), // !
            EXCLEQ = new TokenType(28, "!="), // !=
            LTEQ = new TokenType(29, "<="), // <=
            LT = new TokenType(30, "<"), // <
            GT = new TokenType(31, ">"), // >
            GTEQ = new TokenType(32, ">="), // >=

            PLUSEQ = new TokenType(33, "+="), // +=
            MINUSEQ = new TokenType(34, "-="), // -=
            STAREQ = new TokenType(35, "*="), // *=
            SLASHEQ = new TokenType(36, "/="), // /=
            PERCENTEQ = new TokenType(37, "%="), // %=
            AMPEQ = new TokenType(38, "&="), // &=
            CARETEQ = new TokenType(39, "^="), // ^=
            BAREQ = new TokenType(40, "|="), // |=
            COLONCOLONEQ = new TokenType(41, "::="), // ::=
            LTLTEQ = new TokenType(42, "<<="), // <<=
            GTGTEQ = new TokenType(43, ">>="), // >>=
            GTGTGTEQ = new TokenType(44, ">>>="), // >>>=

            PLUSPLUS = new TokenType(45, "++"), // ++
            MINUSMINUS = new TokenType(46, "--"), // --

            LTLT = new TokenType(47, "<<"), // <<
            GTGT = new TokenType(48, ">>"), // >>
            GTGTGT = new TokenType(49, ">>>"), // >>>

            TILDE = new TokenType(50, "~"), // ~
            CARET = new TokenType(51, "^"), // ^
            BAR = new TokenType(52, "|"), // |
            BARBAR = new TokenType(53, "||"), // ||
            AMP = new TokenType(54, "&"), // &
            AMPAMP = new TokenType(55, "&&"), // &&

            QUESTION = new TokenType(56, "?"), // ?
            COLON = new TokenType(57, ":"), // :
            COLONCOLON = new TokenType(58, "::"), // ::

            LPAREN = new TokenType(59, "("), // (
            RPAREN = new TokenType(60, ")"), // )
            LBRACKET = new TokenType(61, "["), // [
            RBRACKET = new TokenType(62, "]"), // ]
            LBRACE = new TokenType(63, "{"), // {
            RBRACE = new TokenType(64, "}"), // }
            COMMA = new TokenType(65, ","), // ,
            DOT = new TokenType(66, "."), // .
            EOF = new TokenType(67, "<eof>");
    
    public static final TokenType[] KEYWORDS = {
        PRINT, PRINTLN. IF, ELSE, WHILE, FOR, DO, BREAK, CONTINUE, DEF, RETURN, USE, MATCH, CASE, EXTRACT, INCLUDE
    };
    
    private final int value;
    private final String name;

    private TokenType(int value, String name) {
        this.value = value;
        this.name = name;
    }
    
    public int value() {
        return value;
}

    public String name() {
        return name;
    }

    public String toString() {
        return name;
    }
}
