package com.annimon.ownlang.parser.ast;

import com.annimon.ownlang.lib.Value;

/**
 *
 * @author aNNiMON
 */
public final class AssignmentExpression implements Expression, Statement {

    public final Accessible target;
    public final int operation;
    public final Expression expression;
    
    public AssignmentExpression(int operation, Accessible target, Expression expr) {
        this.operation = operation;
        this.target = target;
        this.expression = expr;
    }
    
    /*@Override*/
    public void execute() {
        eval();
    }

    /*@Override*/
    public Value eval() {
        if (operation <= 0) {
            // Simple assignment
            return target.set(expression.eval());
        }
        final Expression expr1 = new ValueExpression(target.get());
        final Expression expr2 = new ValueExpression(expression.eval());
        return target.set(new BinaryExpression(operation, expr1, expr2).eval());
    }
    
    /*@Override*/
    public void accept(Visitor visitor) {
        visitor.visit(this);
    }

    /*@Override*/
    public String toString() {
        final String op = (operation == 0) ? "" : "" + operation;
        return target + " " + op + "= " + expression;
    }
}
