package com.annimon.ownlang.parser.ast;

import com.annimon.ownlang.lib.ArrayValue;
import com.annimon.ownlang.lib.MapValue;
import com.annimon.ownlang.lib.Types;
import com.annimon.ownlang.lib.Value;
import com.annimon.ownlang.lib.Variables;
import com.annimon.stream.Entry;
import java.util.Enumeration;
import java.util.Vector;

/**
 *
 * @author aNNiMON
 */
public final class DestructuringAssignmentStatement implements Statement {
    
    public final Vector/*<String>*/ variables;
    public final Expression containerExpression;

    public DestructuringAssignmentStatement(Vector/*<String>*/ arguments, Expression container) {
        this.variables = arguments;
        this.containerExpression = container;
    }
    
    /*@Override*/
    public void execute() {
        final Value container = containerExpression.eval();
        switch (container.type()) {
            case Types.ARRAY:
                execute((ArrayValue) container);
                break;
            case Types.MAP:
                execute((MapValue) container);
                break;
        }
    }
    
    private void execute(ArrayValue array) {
        final int size = variables.size();
        for (int i = 0; i < size; i++) {
            final String variable = (String) variables.elementAt(i);
            if (variable != null) {
                Variables.set(variable, array.get(i));
            }
        }
    }
    private void execute(MapValue map) {
        int i = 0;
        for (Enumeration en = map.iterator(); en.hasMoreElements();) {
            final Entry entry = (Entry) en.nextElement();
            final String variable = (String) variables.elementAt(i);
            if (variable != null) {
                Variables.set(variable, new ArrayValue(
                        new Value[] { (Value) entry.getKey(), (Value) entry.getValue() }
                ));
            }
            i++;
        }
    }
    
    /*@Override*/
    public void accept(Visitor visitor) {
        visitor.visit(this);
    }

    /*@Override*/
    public String toString() {
        return variables.toString();
    }
}
