package com.annimon.ownlang.parser.ast;

import com.annimon.ownlang.lib.Value;
import com.annimon.ownlang.lib.Variables;
import com.annimon.stream.Iterable;
import java.util.Enumeration;

/**
 *
 * @author aNNiMON
 */
public final class ForeachArrayStatement implements Statement {
    
    public final String variable;
    public final Expression container;
    public final Statement body;

    public ForeachArrayStatement(String variable, Expression container, Statement body) {
        this.variable = variable;
        this.container = container;
        this.body = body;
    }

    /*@Override*/
    public void execute() {
        final Value previousVariableValue = Variables.isExists(variable) ? Variables.get(variable) : null;
        final Iterable/*<Value>*/ iterator = (Iterable/*<Value>*/) container.eval();
        for (Enumeration en = iterator.iterator(); en.hasMoreElements();) {
            final Value value = (Value) en.nextElement();
            Variables.set(variable, value);
            try {
                body.execute();
            } catch (BreakStatement bs) {
                break;
            } catch (ContinueStatement cs) {
                // continue;
            }
        }
        // Восстанавливаем переменную
        if (previousVariableValue != null) {
            Variables.set(variable, previousVariableValue);
        }
    }
    
    /*@Override*/
    public void accept(Visitor visitor) {
        visitor.visit(this);
    }

    /*@Override*/
    public String toString() {
        return "for " + variable + " : " + container + " " + body;
    }
}
